#coding: utf-8

from vcCommand import * 

app = getApplication()
sel = app.SelectionManager
cmd = getCommand()

# Create dialog parameters
p11 = createProperty(VC_REAL, 'Linear::Max Speed'); 
p12 = createProperty(VC_REAL, 'Linear::Max Acceleration')
p13 = createProperty(VC_REAL, 'Linear::Max Deceleration')
p21 = createProperty(VC_REAL, 'Rotational::Max Speed')
p22 = createProperty(VC_REAL, 'Rotational::Max Acceleration')
p23 = createProperty(VC_REAL, 'Rotational::Max Deceleration')
# Set initial 'default' values
p11.Value = 101
p12.Value = 502
p13.Value = 503
p21.Value = 104
p22.Value = 505
p23.Value = 506

def  Hook2(prop):
    try:
        if cur_type == 2: # Linear axis
            cur_dof.MaxSpeed = p11.Value
            cur_dof.MaxAcceleration = p12.Value
            cur_dof.MaxDeceleration = p13.Value
        if cur_type == 1: # Rotational axis
            cur_dof.MaxSpeed = p21.Value
            cur_dof.MaxAcceleration = p22.Value
            cur_dof.MaxDeceleration = p23.Value
    except:
        pass
    prop1.OnChanged = None

def  Hook1():
    global  prop1, cur_dof, cur_type
    node = sel.getSelection(VC_SELECTION_NODE)
    if not node: return
    dof = node[0].Dof
    prop1 = [pp for pp in dof.Properties if pp.Name == 'Controller']
    if not prop1: 
        prop1.OnChanged = None
        return
    prop1 = prop1[0]
    if prop1.Value:
        prop1.OnChanged = None
        return
    prop1.OnChanged = Hook2
    cur_dof = dof
    cur_type = dof.JointLinkType

def OnStart():
    app.findCommand('netCommand').execute('SetLocalizationCommand', 'English', 'Python', cmd.Name, 'Text', 'Link defaults')
    executeInActionPanel()

sel.OnSelectionChanged = Hook1
